

var domain = 'gis-core.sabu.mtu.edu';
var port = '6080';
var protocol = "http://";
var arcgisrest = [protocol, domain, ":",port,"/arcgis/rest/services/"].join('');

// used by geocoder,searchPeople
var placeNameURL    = arcgisrest + "KeweenawHSDI/cchsdi_placenames/MapServer/0";
var StoryPointURL   = arcgisrest + "KeweenawHSDI/cchsdi_storyptsdev/FeatureServer/0";

var searchPhpDomain = 'geospatialresearch.mtu.edu';

var SearchPlaceURL  = protocol + searchPhpDomain + "/search_by_place.php";//?q=place&p=place;
var SearchStoryURL  = protocol + searchPhpDomain + "/search_by_story.php";//?q=place&p=story

var kettTopoMapServerURL = "https://portal1-geo.sabu.mtu.edu:6443/arcgis/rest/services/KeweenawHSDI/KeTT_1940s_TOPO/MapServer";

var kettAllInOneByYears = ['1888','1900','1908','1917','1928','1935','1942','1949'];
var kettAllInOneByYearPattern = "http://portal1-geo.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/KeTT_YYYY_FIPS/MapServer";

var debugLevel = 'prerelease';//'debug' // debug, release

var KeTT_Geocoders = [
         "KeTT_Geocoder_1949",
         "KeTT_Geocoder_1942",
         "KeTT_Geocoder_1935",
         "KeTT_Geocoder_1928",
         "KeTT_Geocoder_1917",
         "KeTT_Geocoder_190708",
         "KeTT_Geocoder_1900",
         "KeTT_Geocoder_1888"];
var GeocoderRootUrl = arcgisrest + "KeweenawHSDI/";

var validServiceConfig = null;
// tiled map services
var kht = {Services:[
	{	id: "AtlanticMine_1949",
		name:"Atlantic Mine",  year:"1949", value:"AtlanticMine", hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/AtMine49_FIPS/MapServer"
	},
   {	id: "Calumet_1949",
		name:"Calumet",  year:"1949", value:"Calumet",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal49FIPS_core/MapServer"
	},{	id: "Calumet_1942",
		name:"Calumet",  year:"1942", value:"Calumet", hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal42FIPS/MapServer"
	},{	id: "Calumet_1928",
		name:"Calumet",  year:"1928", value:"Calumet",hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal28FIPS/MapServer"
	},{	id: "Calumet_1917",
		name:"Calumet",  year:"1917", value:"Calumet",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal17FIPS/MapServer"
	},{	id: "Calumet_1908",
		name:"Calumet",  year:"1908", value:"Calumet",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal08FIPS/MapServer"
	},{	id: "Calumet_1900",
		name:"Calumet",  year:"1900", value:"Calumet",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal00FIPS/MapServer"
	},{	id: "Calumet_1888",
		name:"Calumet",  year:"1888", value:"Calumet",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal88FIPS/MapServer"
	},{	id: "Calumet_1884",
		name:"Calumet",  year:"1884", value:"Calumet",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Cal84FIPS/MapServer"
	},
   {  id: "DollarBay_1907",
		name:"Dollar Bay",   year:"1907", value:"DollarBay",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/DoB07_FIPS/MapServer"
   },
   {  id: "DollarBay_1917",
		name:"Dollar Bay",   year:"1917", value:"DollarBay",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/DoB17_FIPS/MapServer"
   },
   {  id: "DollarBay_1928",
		name:"Dollar Bay",   year:"1928", value:"DollarBay",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/DoB28_FIPS/MapServer"
   },
   {  id: "DollarBay_1942",
		name:"Dollar Bay",   year:"1942", value:"DollarBay",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/DoB42_FIPS/MapServer"
   },
   {  id: "DollarBay_1949",
		name:"Dollar Bay",   year:"1949", value:"DollarBay",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/DollarBay49FIPS/MapServer"
   },
   {  id: "Hancock_1949",
		name:"Hancock",   year:"1949", value:"Hancock",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Hancock49FIPS/MapServer"
   },{
      id: "Hancock_1942",
		name:"Hancock",   year:"1942", value:"Hancock",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Hck42FIPS/MapServer"
   },{
      id: "Hancock_1928",
		name:"Hancock",   year:"1928", value:"Hancock",hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Hck28FIPS/MapServer"
   },{
      id: "Hancock_1917",
		name:"Hancock",   year:"1917", value:"Hancock",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Hck17FIPS/MapServer"
   },{
      id: "Hancock_1907",
		name:"Hancock",   year:"1907", value:"Hancock",hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Hck07FIPS/MapServer"
   },{
      id: "Hancock_1900",
		name:"Hancock",   year:"1900", value:"Hancock",hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Hck00FIPS/MapServer"
   },{
      id: "Hancock_1888",
		name:"Hancock",   year:"1888", value:"Hancock",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Hck88_FIPS/MapServer"
   },
   {  id: "Houghton_1949",
		name:"Houghton",  year:"1949",  value:"Houghton", hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Htn49_FIPS/MapServer"
	},{
		id: "Houghton_1928",
		name:"Houghton",  year:"1928",  value:"Houghton", hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Htn28_FIPS/MapServer"
	},{
		id: "Houghton_1917",
		name:"Houghton",  year:"1917",  value:"Houghton", hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Htn17_FIPS/MapServer"
	},{
		id: "Houghton_1908",
		name:"Houghton",  year:"1908",  value:"Houghton", hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Htn08_FIPS/MapServer"
	},{
		id: "Houghton_1900",
		name:"Houghton",  year:"1900",  value:"Houghton",	hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Htn00_FIPS/MapServer"
	},{
		id: "Houghton_1888",
		name:"Houghton",  year:"1888",  value:"Houghton",	hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Htn88_FIPS/MapServer"
	},
   {
		id: "LakeLinden_1935",
		name:"Lake Linden",  year:"1935", value:"LakeLinden", hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/LL35FIPS/MapServer"
	},{
		id: "LakeLinden_1928",
		name:"Lake Linden",  year:"1928", value:"LakeLinden", hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/LL28FIPS/MapServer"
	},{
		id: "LakeLinden_1917",
		name:"Lake Linden",  year:"1917", value:"LakeLinden", hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/LL17FIPS/MapServer"
	},{
		id: "LakeLinden_1908",
		name:"Lake Linden",  year:"1908", value:"LakeLinden", hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/LL08FIPS/MapServer"
	},{
		id: "LakeLinden_1900",
		name:"Lake Linden",  year:"1900", value:"LakeLinden", hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/LL00FIPS/MapServer"
	},{
		id: "LakeLinden_1888",
		name:"Lake Linden",  year:"1888", value:"LakeLinden", hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/LL1888FIPS/MapServer"
	},
   {	id: "Laurium_1949",
		name:"Laurium",  year:"1949", value:"Laurium",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Laurium49FIPS/MapServer"
	},{
		id: "Laurium_1942",
		name:"Laurium",  year:"1942", value:"Laurium",hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Laurium42_FIPS/MapServer"
	},{
		id: "Laurium_1917",
		name:"Laurium",  year:"1917", value:"Laurium",hasColor:false,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Laurium17_FIPS/MapServer"
	},{
		id: "Laurium_1908",
		name:"Laurium",  year:"1908", value:"Laurium",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Laurium08_FIPS/MapServer"
	},{
		id: "Laurium_1900",
		name:"Laurium",  year:"1900", value:"Laurium",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Laurium00_FIPS/MapServer"
	},{
		id: "Laurium_1888",
		name:"Laurium",  year:"1888", value:"Laurium",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Laurium88_FIPS/MapServer"
	},
   {	id: "Mohawk_1949",
		name:"Mohawk",  year:"1949", value:"Mohawk",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Mohawk49FIPS/MapServer"
	},
   {	id: "Quincy_1883",
		name:"Quincy",  year:"1883", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Quincy1883/MapServer"
	},
   {	id: "Quincy_1888",
		name:"Quincy",  year:"1888", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Qcy88_FIPS/MapServer"
	},
   {	id: "Quincy_1900",
		name:"Quincy",  year:"1900", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Qcy00_FIPS/MapServer"
	},
   {	id: "Quincy_1907",
		name:"Quincy",  year:"1907", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Qcy07_FIPS/MapServer"
	},
   {	id: "Quincy_1917",
		name:"Quincy",  year:"1917", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Qcy17_FIPS/MapServer"
	},
   {	id: "Quincy_1928",
		name:"Quincy",  year:"1928", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Qcy28_FIPS/MapServer"
	},
   {	id: "Quincy_1942",
		name:"Quincy",  year:"1942", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Qcy42_FIPS/MapServer"
	},
   {	id: "Quincy_1949",
		name:"Quincy",  year:"1949", value:"Quincy",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/Quincy49FIPS/MapServer"
	},
   {	id: "SouthHoughtonCounty_1949",
		name:"South Houghton County",  year:"1949", value:"SouthHoughtonCounty",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/SoHoCo49_FIPS/MapServer"
	},
   {	id: "SouthRange_1949",
		name:"South Range",  year:"1949", value:"SouthRange",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/SoRange49_FIPS/MapServer"
	}

]};

 /*
 {	id: "LakeLinden_1949",
		name:"Lake Linden",  year:"1949", value:"LakeLinden",
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/LL49FIPS/MapServer"
	},
 {	id: "KeweenawCounty_1949",
		name:"Keweenaw County",  year:"1949", value:"KeweenawCounty", hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/KewCo49FIPS/MapServer"
	},
   {	id: "NorthHoughtonCounty_1949",
		name:"North Houghton County",  year:"1949", value:"NorthHoughtonCounty",hasColor:true,
		mapservice:       "http://gis-core.sabu.mtu.edu:6080/arcgis/rest/services/KeweenawHSDI/NoHoCo49FIPS/MapServer"
	},
   */

var decadeBin = {Services:[
	{
		label:"1880s",  startYear: 1875 , endYear: 1889,
		townservice:[
      {name:"Calumet",     year: 1888, mapservice:"Cal88FIPS"},
      {name:"Houghton",    year: 1888, mapservice:"Htn88_FIPS"},
      {name:"Laurium",     year: 1888, mapservice:"Laurium88FIPS"},
      {name:"Lake Linden", year: 1885, mapservice:"LL1885FIPS"},
      {name:"Quincy",      year: 1883, mapservice:"Quincy1883"},
      {name:"Hancock",     year: 1888, mapservice:"Hck88_FIPS"},
      {name:"Mohawk",      year: 0,    mapservice:""},
      {name:"Dollar Bay",  year: 0,    mapservice:""},
      {name:"South Houghton County",   year: 0, mapservice:""},
      {name:"South Range",             year: 0, mapservice:""},
      ]
	},
   {
      label:"1890s",  startYear: 1890 , endYear: 1898,
		townservice:[
      {name:"Calumet",     year: 1893, mapservice:"Cal93FIPS"},
      {name:"Houghton",    year: 1888, mapservice:"Htn88_FIPS"},
      {name:"Laurium",     year: 1888, mapservice:"Laurium88FIPS"},
      {name:"Lake Linden", year: 1893, mapservice:"LL1893FIPS"},
      {name:"Quincy",      year: 1888, mapservice:"Qcy88_FIPS"},
      {name:"Hancock",     year: 0,    mapservice:""},
      {name:"Mohawk",      year: 0,    mapservice:""},
      {name:"Dollar Bay",  year: 0,    mapservice:""},
      {name:"South Houghton County",   year: 0, mapservice:""},
      {name:"South Range",             year: 0, mapservice:""},
      ]
	} ,
   {
      label:"1900s",  startYear: 1899 , endYear: 1913,
		townservice:[
      {name:"Calumet",     year: 1908, mapservice:"Cal08FIPS"},
      {name:"Houghton",    year: 1900, mapservice:"Htn00_FIPS"},
      {name:"Laurium",     year: 1900, mapservice:"Laurium00_FIPS"},
      {name:"Lake Linden", year: 1900, mapservice:"LL00FIPS"},
      {name:"Quincy",      year: 1907, mapservice:"Qcy07_FIPS"},
      {name:"Hancock",     year: 1907, mapservice:"Hck07FIPS"},
      {name:"Mohawk",      year: 0,    mapservice:""},
      {name:"Dollar Bay",  year: 1907, mapservice:"DoB07_FIPS"},
      {name:"South Houghton County",   year: 0, mapservice:""},
      {name:"South Range",             year: 0, mapservice:""},
      ]
	} ,
   {
      label:"1910s",  startYear: 1914 , endYear: 1924,
		townservice:[
      {name:"Calumet",     year: 1917, mapservice:"Cal17FIPS"},
      {name:"Houghton",    year: 1917, mapservice:"Htn17_FIPS"},
      {name:"Laurium",     year: 1917, mapservice:"Laurium17_FIPS"},
      {name:"Lake Linden", year: 1917, mapservice:"LL17FIPS"},
      {name:"Quincy",      year: 1917, mapservice:"Qcy17_FIPS"},
      {name:"Hancock",     year: 1917, mapservice:"Hck17FIPS"},
      {name:"Mohawk",      year: 0,    mapservice:""},
      {name:"Dollar Bay",  year: 1917, mapservice:"DoB17_FIPS"},
      {name:"South Houghton County",   year: 0, mapservice:""},
      {name:"South Range",             year: 0, mapservice:""},
      ]
	},
   {
      label:"1920s",  startYear: 1925 , endYear: 1938,
		townservice:[
      {name:"Calumet",     year: 1928, mapservice:"Cal28FIPS"},
      {name:"Houghton",    year: 1928, mapservice:"Htn28_FIPS"},
      {name:"Laurium",     year: 1917, mapservice:"Laurium17_FIPS"},
      {name:"Lake Linden", year: 1928, mapservice:"LL28FIPS"},
      {name:"Quincy",      year: 1928, mapservice:"Qcy28_FIPS"},
      {name:"Hancock",     year: 1928, mapservice:"Hck28FIPS"},
      {name:"Mohawk",      year: 0,    mapservice:""},
      {name:"Dollar Bay",  year: 1928, mapservice:"DoB28_FIPS"},
      {name:"South Houghton County",   year: 0, mapservice:""},
      {name:"South Range",             year: 0, mapservice:""},
      ]
	} ,
   {
      label:"1930s",  startYear: 1939 , endYear: 1945,
		townservice:[
      {name:"Calumet",     year: 1942, mapservice:"Cal42FIPS"},
      {name:"Houghton",    year: 1949, mapservice:"Htn49_FIPS"},
      {name:"Laurium",     year: 1942, mapservice:"Laurium42_FIPS"},
      {name:"Lake Linden", year: 1935, mapservice:"LL35FIPS"},
      {name:"Quincy",      year: 1942, mapservice:"Qcy42_FIPS"},
      {name:"Hancock",     year: 1942, mapservice:"Hck42FIPS"},
      {name:"Mohawk",      year: 0,    mapservice:""},
      {name:"Dollar Bay",  year: 1942, mapservice:"DoB42_FIPS"},
      {name:"South Houghton County",   year: 0, mapservice:""},
      {name:"South Range",             year: 0, mapservice:""},
      ]
	} ,
   {
      label:"1940-50s",  startYear: 1946 , endYear: 1955,
		townservice:[
      {name:"Calumet",     year: 1949, mapservice:"Cal49FIPS_core"},
      {name:"Houghton",    year: 1949, mapservice:"Htn49_FIPS"},
      {name:"Laurium",     year: 1949, mapservice:"Laurium49FIPS"},
      {name:"Lake Linden", year: 1935, mapservice:"LL35FIPS"},
      {name:"Quincy",      year: 1949, mapservice:"Quincy49FIPS"},
      {name:"Hancock",     year: 1949, mapservice:"Hancock49FIPS"},
      {name:"Mohawk",      year: 1949, mapservice:"Mohawk49FIPS"},
      {name:"Dollar Bay",  year: 0,    mapservice:""},
      {name:"South Houghton County",   year: 1949, mapservice:"SoHoCo49_FIPS"},
      {name:"South Range",             year: 1949, mapservice:"SoRange49_FIPS"},
      ]
	}
	]};


   var townCentroid = {centroids:[
      {name:"Atlantic Mine",     x: -9865858.848229574, y:5958405.768294633},
      {name:"Calumet",     x: -9846662.3455, y:5982448.0482},
      {name:"Dollar Bay",     x: -9852035.1578, y:5961648.7522},
      {name:"Hancock",     x: -9860765.5904, y:5962775.4182},
      {name:"Houghton",     x: -9859353.5877, y:5961980.4714},
      {name:"Lake Linden",     x: -9841696.5644, y:5973452.658},
      {name:"Laurium",     x: -9845522.658, y:5980860.6264},
      {name:"Mohawk",     x: -9836527.2678, y:5991687.6573},
      {name:"Quincy",     x: -9860501.4074, y:5963928.1271},
      {name:"South Houghton County",     x: -9866592.9165, y:5952530.2375},
      {name:"South Range",     x: -9867820.9973, y:5953686.6803}
	]};
